<?php
namespace nur\sery\wip\schema\types;

use nulib\cl;
use nulib\php\func;

class Registry {
  const TYPES = [
    "rawstring" => trawstring::class,
    "string" => tstring::class,
    "bool" => tbool::class, "boolean" => tbool::class,
    "int" => tint::class, "integer" => tint::class,
    "float" => tfloat::class, "flt" => tfloat::class,
    "double" => tfloat::class, "dbl" => tfloat::class,
    "array" => tarray::class,
    "callable" => tcallable::class,
    # types spéciaux
    "key" => tkey::class,
    "pkey" => tpkey::class,
    "content" => tcontent::class,
  ];

  function __construct() {
    $this->types = [];
  }

  /** @var IType[] */
  protected $types;

  function get(string $name, ?array $params=null): IType {
    if ($params !== null) {
      $class = self::TYPES[$name];
      return func::with([$class, false, $params])->invoke();
    }
    $type = cl::get($this->types, $name);
    if ($type === null) {
      $class = self::TYPES[$name];
      $type = $this->types[$name] = new $class();
    }
    return $type;
  }
}
